<?php
namespace EMS\PortalFuncionario\Geral\Controllers;

use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Doctrine\ORM\EntityManager;

use EMS\PortalFuncionario\Geral\Services\AcompanhamentoService;

class AcompanhamentoController extends Crud {

    // protected $dataSourceName = 'employees';

    public function __construct(EntityManager $entityManager, AcompanhamentoService $acompanhamentoService) {
        $this->entityManager            = $entityManager;
        $this->acompanhamentoService    = $acompanhamentoService;
    }

    public function getAcompanhamento(DTO\Request\Filter $request, DTO\Response $response) {
        try {
            $params = $request->getParameters();
            $acompanhamento = $this->acompanhamentoService->getAcompanhamento(
                $params['NRORG'],
                $params['NRVINCULOM'],
                $params['NRPERIODOAPURACAO']
            );
            $response->addDataSet(new DataSet('acompanhamento', $acompanhamento));
        } catch (\Exception $e) {
            $response->addMessage(new DTO\Response\Message($e->getMessage(), DTO\Response\Message::TYPE_ERROR));
        }
    }
}
