<?php
namespace EMS\PortalFuncionario\Geral\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Doctrine\ORM\EntityManager;

use EMS\PortalFuncionario\Geral\Services\DemonstrativoPagamentoService;

class DemonstrativoPagamentoController {

    public function __construct(EntityManager $entityManager, DemonstrativoPagamentoService $demonstrativoPagamentoService) {
        $this->entityManager                    = $entityManager;
        $this->demonstrativoPagamentoService    = $demonstrativoPagamentoService;
    }

    public function getDemonstrativoPagamento(DTO\Request\Filter $request, DTO\Response $response) {
        try {
            $params = $request->getParameters();
            $demonstrativoPagamento = $this->demonstrativoPagamentoService->getDemonstrativoPagamento(
                $params['NRORG'],
                $params['NRVINCULOM'],
                $params['DTMESCOMPETENC'],
                $params['NRTIPOMOVIMENT'],
                $params['NRTPMODALIDCAL'],
                $params['OCORRECAL'],
                $params['IGNORAOCORR']
            );
            $response->addDataSet(new DataSet('demonstrativoPagamento', $demonstrativoPagamento));
        } catch (\Exception $e) {
            $response->addMessage(new DTO\Response\Message($e->getMessage(), DTO\Response\Message::TYPE_ERROR));
        }
    }

    public function getEstruturasByVincMultiplo(DTO\Request\Filter $request, DTO\Response $response) {
        try {
            $row = $request->getParameters();
            $dados = $this->demonstrativoPagamentoService->getEstruturasByVincMultiplo($row);
            $response->addDataSet(new DataSet('getEstruturasByVincMultiplo', $dados));
        } catch (\Exception $e) {
            $response->addMessage(new DTO\Response\Message($e->getMessage(), DTO\Response\Message::TYPE_ERROR));
        }
    }

}