<?php
namespace EMS\PortalFuncionario\Geral\Controllers;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;

use EMS\PortalFuncionario\Geral\Services\MenuService;

class MenuController {
    public function __construct(MenuService $menuService) {
        $this->menuService = $menuService;
    }
    
    public function buildMenu(DTO\Request\Filter $request, DTO\Response $response) {
        try {
            $parameters = $request->getparameters();
            $param = isset($parameters['filter']) ? $parameters['filter'][0] : $parameters;
            
            $concatenateGroupMenu = $param['name'] === 'CONCATENATE_GROUP_MENU' ? $param['value'] : true;
            $visibleMenus         = ["5209739341644419495255", "1287389172389712897381923"];
            $expiredMenus         = [];
            $urlOrigin            = "";
            $currentModule        = "";
            $currentLanguage      = "pt-br";

            $routesAndMenu        = $this->menuService->buildMenu($concatenateGroupMenu, $visibleMenus, $expiredMenus, $urlOrigin,
                $currentModule, $currentLanguage);
            $response->addDataSet(new DataSet('menu', $routesAndMenu['MENUS']));
            $response->addDataSet(new DataSet('routesTranslate', $routesAndMenu['ROUTES_TRANSLATE']));
        } catch(CustomException $e) {
            $response->setError(Utilities::getErrorObjectFromException($e));
        }
    }

    public function requestToken(DTO\Request\Filter $request, DTO\Response $response) {
        try {
            // $httpRequest = $this->kernel->getHttpRequest();
            // $clientId = $httpRequest->get('CLIENT_ID');
            // $clientSecret = $httpRequest->get('CLIENT_SECRET');
            // $token = $this->oauth->grantAccessToken($clientId, $clientSecret, array('sessionId' => InstanceProvider::getSession()->getId()));
            // $response->addDataSet(new DataSet('token', array($token)));
            $response->addDataSet(new DataSet('token', array(1)));
        } catch (\Exception $e){
            $response->setError(new DTO\Response\Error($e->getMessage(), DTO\Response\Message::TYPE_ERROR));
        }

    }

    public function getValorReferencia(DTO\Request\Filter $request, DTO\Response $response) {
        try {
            $row = $request->getParameters();
            $dados = $this->menuService->getValorReferencia($row);
            $response->addDataSet(new DataSet('getValorReferencia', $dados));
        } catch (\Exception $e) {
            $response->addMessage(new DTO\Response\Message($e->getMessage(), DTO\Response\Message::TYPE_ERROR));
        }
    }
}