<?php

namespace EMS\PortalFuncionario\Geral\Repository;

use Doctrine\ORM\EntityManager;

class ParamOrgRepository {

    public function __construct(EntityManager $entityManager) {
        $this->connection           = $entityManager->getConnection();
        $this->entityManager        = $entityManager;
    }

    public function getParamOrg(string $nrorg): array {
        $sql = <<<SQL
            SELECT *
              FROM GPE_PARAMORG PO
             WHERE PO.NRORG = :P_NRORG
SQL;

        $query = $this->connection->prepare($sql);

        $query->execute(
            array(
                "P_NRORG"       => $nrorg
            )
        );

        $result = $query->fetchAll();

        return !empty($result) ? $result[0] : $result;
    }

    public function getValorReferencia(
        array $params
    ) {
        $sql = <<<SQL
            SELECT
                *
            FROM
                FPA_VALORREFERENCIAM RM
                JOIN
                FPA_VALORREFERENCIAH RH ON
                    RH.NRORG = RM.NRORG AND
                    RH.NRVALORREFERENCIAM = RM.NRVALORREFERENCIAM AND
                    RH.DTMESCOMPETENC = (
                        SELECT
                            MAX(DTMESCOMPETENC)
                        FROM
                            FPA_VALORREFERENCIAH RH1
                        WHERE
                            RH1.NRORG = RM.NRORG AND
                            RH1.NRVALORREFERENCIAM = RM.NRVALORREFERENCIAM AND
                            RH1.DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY')
                    )
            WHERE
                RM.NRORG = :P_NRORG AND
                RM.DSREFERENCIA = :P_DSREFERENCIA AND
                (
                    RM.DTINIVIGENCIA <= SYSDATE OR
                    RM.DTINIVIGENCIA IS NULL
                ) AND
                (
                    RM.DTFIMVIGENCIA > TRUNC(SYSDATE) OR
                    RM.DTFIMVIGENCIA IS NULL
                )
SQL;

        $std = $this->connection->prepare($sql);
        $std->execute($params);

        $result = $std->fetch();

        return $result;
    }
}