<?php
namespace EMS\PortalFuncionario\Geral\Services;

use Doctrine\ORM\EntityManager;

use EMS\PortalFuncionario\Geral\Repository\DemonstrativoPagamentoRepository;
use EMS\PortalFuncionario\Geral\Services\ParamOrgService;
use EMS\PortalFuncionario\Util\{ HcmServices };

class DemonstrativoPagamentoService  {

    public function __construct(
        EntityManager $entityManager,
        DemonstrativoPagamentoRepository $demonstrativoPagamentoRepository,
        HcmServices         $hcmServices,
        ParamOrgService $paramOrgService
    ) {
        $this->entityManager                    = $entityManager;
        $this->demonstrativoPagamentoRepository = $demonstrativoPagamentoRepository;
        $this->hcmServices                      = $hcmServices;
        $this->paramOrgService                  = $paramOrgService;
    }

    public function getDemonstrativoPagamento(string $nrorg, string $nrvinculom, string $dtmescompetenc, string $nrtipomoviment, string $nrtpmodalidcal, string $ocorrecal, string $ignoraocorr) {
        try {

            try {
                $anoReferencia = $this->paramOrgService->getValorReferenciaPF($nrorg, 'ANO_INICIO', date('01/m/Y'));

                $anoCompetencia = date('Y', strtotime($dtmescompetenc));

                if ((int)$anoCompetencia < (int)$anoReferencia) {
                    $inicioAno = '01/01/' . $anoReferencia;
                    throw new \Exception('Não é possível visualizar informações anteriores à data ' . $inicioAno);
                }

            }  catch (\Exception $e) {
                throw $e;
            }

            return $this->demonstrativoPagamentoRepository->getDemonstrativoPagamento(
                $nrorg,
                $nrvinculom,
                $dtmescompetenc,
                $nrtipomoviment,
                $nrtpmodalidcal,
                $ocorrecal,
                $ignoraocorr
            );
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function getEstruturasByVincMultiplo(
        $row
    ) {
        $nrOrg = (int) $row['NRORG'];

        $hcmServicesRoute = 'getEstruturasByVincMultiplo';

        $params = [
            'requestType'   => 'Row',
            'row'           => $row,
        ];

        $response = $this->hcmServices->send($hcmServicesRoute, $params, $nrOrg);
        $status = (array) $response['dataset'][$hcmServicesRoute];

        return $status;
    }

}