-- ============================================================
--   TABLE: USR_SAP_PRODUTO
-- ============================================================
CREATE TABLE USR_SAP_PRODUTO
(
   CDPRODUTO    VARCHAR2(20) NOT NULL,
   NMPRODUTO    VARCHAR2(50) NOT NULL,
   SGUNIDADE    VARCHAR2(10) NOT NULL,
   VRFATORCONV  FLOAT        NOT NULL,
   CDNCM        VARCHAR2(10) NULL,
   IDPRODATIVPR VARCHAR2(1)  NOT NULL
      CONSTRAINT CKC_IDPRODATIVPR_SAP CHECK (IDPRODATIVPR IN ('A','I')),
   IDINTERFACE NUMBER       NOT NULL,
   TPINTERFACE VARCHAR2(1)  NOT NULL
      CONSTRAINT CKC_TPINTERFACE_USR_SAP_PROD CHECK (TPINTERFACE IN ('I','A','E')),
   DTINTERFACEORI  DATE     NOT NULL,
   DTINTERFACEDEST DATE,
   STATUS      NUMBER       NOT NULL
      CONSTRAINT CKC_STATUS_USR_SAP_PROD CHECK (STATUS IN (0,1,2,3)),
   APPORIGEM   NUMBER       NOT NULL
      CONSTRAINT CKC_APPORIGEM_USR_SAP_PROD CHECK (APPORIGEM IN (1,2)),
   APPDESTINO  NUMBER       NOT NULL
      CONSTRAINT CKC_APPDESTINO_USR_SAP_PROD CHECK (APPDESTINO IN (1,2))
)
/
ALTER TABLE PRODUTO
ADD USR_DTATUEXP_SAP DATE
/
CREATE SEQUENCE USR_CCH_IDINT_PROD INCREMENT BY 1 MINVALUE 1
/


-- ============================================================
--   TABLE: USR_SAP_FILIAL
-- ============================================================
CREATE TABLE USR_SAP_FILIAL
(
   CDFILIAL        VARCHAR2(04) NOT NULL,
   NMFILIAL        VARCHAR2(30) NOT NULL,
   CDEMPINTEGRACAO VARCHAR2(04) NOT NULL,
   CDINSCESTA      VARCHAR2(16) NOT NULL,
   CDINSCMUNI      VARCHAR2(16) NOT NULL,
   DSENDERECOP     VARCHAR2(40)         ,
   CDPAISP         VARCHAR2(04) NOT NULL,
   SGESTADOP       VARCHAR2(02) NOT NULL,
   CDMUNICIPIOP    VARCHAR2(07) NOT NULL,
   CDCEPP          VARCHAR2(15),
   NMBAIRROP       VARCHAR2(30),
   EMAIL           VARCHAR2(40),
   DSENDERECOC     VARCHAR2(40),
   CDPAISC         VARCHAR2(04),
   SGESTADOC       VARCHAR2(02),
   CDMUNICIPIOC    VARCHAR2(07),
   CDCEPC          VARCHAR2(15),
   NMBAIRROC       VARCHAR2(30),
   NRINSJURFILI	   VARCHAR2(20) NOT NULL,
   NMRAZSOCFILI    VARCHAR2(40) NULL,
   CELOG           VARCHAR2(04) NOT NULL,
   CECO            VARCHAR2(10) NOT NULL,
   IDINTERFACE     NUMBER       NOT NULL,
   TPINTERFACE     VARCHAR2(01) NOT NULL
                   CONSTRAINT CKC_TPINTERFACE_USR_SAP_FIL CHECK (TPINTERFACE IN ('I','A','E')),
   DTINTERFACEORI  DATE         NOT NULL,
   DTINTERFACEDEST DATE,
   STATUS          NUMBER       NOT NULL
           CONSTRAINT CKC_STATUS_USR_SAP_FIL CHECK (STATUS IN (0,1,2)),
   APPORIGEM       NUMBER       NOT NULL,
           CONSTRAINT CKC_APPORIGEM_USR_SAP_FIL CHECK (APPORIGEM IN (1,2)),
   APPDESTINO      NUMBER       NOT NULL
           CONSTRAINT CKC_APPDESTINO_USR_SAP_FIL CHECK (APPDESTINO IN (1,2))
)
/
CREATE INDEX CCH_PARAMEMPRESA_01 ON PARAMEMPRESA (CDEMPINTEGRACAO ASC)
/
CREATE SEQUENCE USR_CCH_IDINT_FILI INCREMENT BY 1 MINVALUE 1
/


-- ============================================================
--   TABLE: USR_SAP_FORNECEDOR
-- ============================================================
CREATE TABLE USR_SAP_FORNECEDOR
(
   CDFORNECEDOR    VARCHAR2(20) NOT NULL,
   NMRAZAOSOC      VARCHAR2(40) NOT NULL,
   NMFANTFORNE     VARCHAR2(40) NOT NULL,
   DSENDERECOP     VARCHAR2(40) NOT NULL,
   CDPAISP         VARCHAR2(04) NOT NULL,
   SGESTADOP       VARCHAR2(02) NOT NULL,
   CDMUNICIPIOP    VARCHAR2(07) NOT NULL,
   CDCEPP          VARCHAR2(15),
   NMBAIRROP       VARCHAR2(30),
   EMAIL           VARCHAR2(40),
   IDTPIJURFORN    VARCHAR2(01) NOT NULL,
   NRINSJURFORN    VARCHAR2(20) NOT NULL,
   NRINSESTFORN    VARCHAR2(20) NULL,
   IDTIPOFORN      VARCHAR2(01) NULL,
   IDFORMPGFORN    VARCHAR2(01) NULL,
   CDCSTDIG1ENT    VARCHAR2(01) NULL,
   IDSITUCADA      VARCHAR2(01) NULL,
   NRNOTAFORN      NUMBER(3) NULL,
   CDQUALIF        VARCHAR2(02) NULL,
   DTVALQUALIF     DATE NULL,
   IDTPFORPGTFO    VARCHAR2(01) NULL,
   NRPARCPGTOFO    NUMBER(2) NULL,
   NRDIAPGFIXFO    NUMBER(2) NULL,
   IDUTDIAPGTFO    VARCHAR2(01) NULL,
   IDGERAFDTENT    VARCHAR2(01) NULL,
   IDFORNAUTO      VARCHAR2(01) NULL,
   IDENDEMISFOR    VARCHAR2(01) NULL,
   IDENDCFOPFOR    VARCHAR2(01) NULL,
   DTULTATUFORN    DATE NULL,
   CDTIPOFORN      VARCHAR2(03) NULL,
   IDPRIPUBFORN    VARCHAR2(01) NULL,
   IDAGRUBOLFOR    VARCHAR2(01) NULL,
   IDLIGEXTFORN    VARCHAR2(01) NULL,
   VRPERPIFORN     FLOAT NULL,
   IDFORNINTER     VARCHAR2(01) NULL,
   IDTPENDEFORN    VARCHAR2(01) NULL,
   NRTELEFORN      VARCHAR2(25) NULL,
   NRRAMALFORN     VARCHAR2(04) NULL,
   NRFAXFORN       VARCHAR2(25) NULL,
   NMCONTFORN      VARCHAR2(30) NULL,
   DTULTATUENFO    DATE NULL,
   NMCOMPRZSFOR    VARCHAR2(200) NULL,
   CDEXFORNECED    VARCHAR2(30) NULL,
   DSCOMPENDFOR    VARCHAR2(200) NULL,
   IDUTLALVFORN    VARCHAR2(01) NULL,
   NRALVARAFORN    VARCHAR2(100) NULL,
   DTALVARAFORN    DATE NULL,
   OBSQUALFORNSAP  VARCHAR2(250) NULL,
   IDINTERFACE     NUMBER       NOT NULL,
   TPINTERFACE     VARCHAR2(01) NOT NULL
          CONSTRAINT CKC_TPINTERFACE_USR_SAP_FORN CHECK (TPINTERFACE IN ('I','A','E')),
   DTINTERFACEORI  DATE         NOT NULL,
   DTINTERFACEDEST DATE,
   STATUS          NUMBER       NOT NULL
          CONSTRAINT CKC_STATUS_USR_SAP_FORN CHECK (STATUS IN (0,1,2)),
   APPORIGEM       NUMBER       NOT NULL
          CONSTRAINT CKC_APPORIGEM_USR_SAP_FORN CHECK (APPORIGEM IN (1,2)),
   APPDESTINO      NUMBER       NOT NULL
          CONSTRAINT CKC_APPDESTINO_USR_SAP_FORN CHECK (APPDESTINO IN (1,2))
)
/
CREATE SEQUENCE USR_CCH_IDINT_FORN INCREMENT BY 1 MINVALUE 1
/


-- ============================================================
--   TABLE: USR_SAP_CLIENTE
-- ============================================================
CREATE TABLE USR_SAP_CLIENTE
(
   CDCLIENTE       VARCHAR2(20) NOT NULL,
   NMRAZAOSOC      VARCHAR2(40) NOT NULL,
   NMFANTCLIE      VARCHAR2(40) NOT NULL,
   DSENDERECOP     VARCHAR2(40) NOT NULL,
   CDPAISP         VARCHAR2(04) NOT NULL,
   SGESTADOP       VARCHAR2(02) NOT NULL,
   CDMUNICIPIOP    VARCHAR2(07) NOT NULL,
   CDCEPP          VARCHAR2(15),
   NMBAIRROP       VARCHAR2(30),
   EMAIL           VARCHAR2(40),
   IDTPIJURCLIE    VARCHAR2(01) NOT NULL,
   NRINSJURCLIE    VARCHAR2(20) NOT NULL,
   NRINSESTCLIE    VARCHAR2(20) NULL,
   CDFORMPGTO      VARCHAR2(02) NULL,
   IDTPFORPGTCL    VARCHAR2(01) NULL,
   NRPARCPGTOCL    NUMBER       NULL,
   NRDIAPGFIXCL    NUMBER       NULL,
   IDUTDIAPGTCL    VARCHAR2(01) NULL,
   CDCSTDIG1CLI    VARCHAR2(01) NULL,
   IDENDEMISCLI    VARCHAR2(01) NULL,
   IDENDCFOPCLI    VARCHAR2(01) NULL,
   IDTIPINFCOME    VARCHAR2(01) NULL,
   DTCADACLIE      DATE         NULL,
   IDCLIECONTRI    VARCHAR2(01) NULL,
   IDCLIEATIV      VARCHAR2(01) NULL,
   IDSEGCLIP       VARCHAR2(01) NULL,
   IDTERCLIP       VARCHAR2(01) NULL,
   IDQUACLIP       VARCHAR2(01) NULL,
   IDQUICLIP       VARCHAR2(01) NULL,
   IDSEXCLIP       VARCHAR2(01) NULL,
   IDSABCLIP       VARCHAR2(01) NULL,
   IDDOMCLIP       VARCHAR2(01) NULL,
   IDRECINFMKT     VARCHAR2(01) NULL,
   IDPRIPUBCLIE    VARCHAR2(01) NULL,
   IDVERSALDCLI    VARCHAR2(01) NULL,
   IDUTSALDCLI     VARCHAR2(01) NULL,
   IDCALCDVCLIE    VARCHAR2(01) NULL,
   IDUTSUBCLIEN    VARCHAR2(01) NULL,
   IDLIBGERPER     VARCHAR2(01) NULL,
   IDZERSALDCON    VARCHAR2(01) NULL,
   IDGERNFCLIE     VARCHAR2(01) NULL,
   IDSITFINCLIE    VARCHAR2(01) NULL,
   IDLIGEXTCLIE    VARCHAR2(01) NULL,
   IDCLIEAUTO      VARCHAR2(01) NULL,
   IDGERANFPEDI    VARCHAR2(01) NULL,
   IDUTCONSPEDI    VARCHAR2(01) NULL,
   IDTPENDECLIE    VARCHAR2(01) NULL,
   DSCOMPENDCLI    VARCHAR2(200) NULL,
   NRTELECLIE      VARCHAR2(25) NULL,
   NRRAMALCLIE     VARCHAR2(04) NULL,
   NRFAXCLIE       VARCHAR2(25) NULL,
   NMCOMPRZSCLI    VARCHAR2(200) NULL,
   CDEXCLIENTE     VARCHAR2(30) NULL,
   IDINTERFACE     NUMBER       NOT NULL,
   TPINTERFACE     VARCHAR2(01) NOT NULL
          CONSTRAINT CKC_TPINTERFACE_USR_SAP_CLI CHECK (TPINTERFACE IN ('I','A','E')),
   DTINTERFACEORI  DATE         NOT NULL,
   DTINTERFACEDEST DATE,
   STATUS          NUMBER       NOT NULL
          CONSTRAINT CKC_STATUS_USR_SAP_CLI CHECK (STATUS IN (0,1,2)),
   APPORIGEM       NUMBER       NOT NULL
          CONSTRAINT CKC_APPORIGEM_USR_SAP_CLI CHECK (APPORIGEM IN (1,2)),
   APPDESTINO      NUMBER       NOT NULL
          CONSTRAINT CKC_APPDESTINO_USR_SAP_CLI CHECK (APPDESTINO IN (1,2))
)
/
CREATE SEQUENCE USR_CCH_IDINT_CLIE INCREMENT BY 1 MINVALUE 1
/


-- ============================================================
--   TABLE: USR_SAP_CLIENFILIAL
-- ============================================================
CREATE TABLE USR_SAP_CLIENFILIAL
(
   CDCLIENTE       VARCHAR2(21) NOT NULL,
   CDFILIAL        VARCHAR2(4)  NOT NULL,
   IDCLIENPRIN     VARCHAR2(1)  NOT NULL
      CONSTRAINT CKC_IDCLIENPRIN_SAP CHECK (IDCLIENPRIN IN ('S','N')),
   IDUTILADIANT    VARCHAR2(1)  NOT NULL
      CONSTRAINT CKC_IDUTILADIANT_SAP CHECK (IDUTILADIANT IN ('S','N')),
   VRPERATDESP     FLOAT,
   IDUTCONTCLPR    VARCHAR2(1)
      CONSTRAINT CKC_IDUTCONTCLPR_SAP CHECK (IDUTCONTCLPR IN ('S','N')),
   IDPERIODFATC    VARCHAR2(1)
      CONSTRAINT CKC_IDPERIODFATC_SAP CHECK (IDPERIODFATC IN ('1','2','3','4')),
   IDCOREFECLIFILI VARCHAR2(1)  NOT NULL
      CONSTRAINT CKC_IDCOREFECLIFILI_SAP CHECK (IDCOREFECLIFILI IN ('U','Q','I')),
   IDCONSMINEFECLI VARCHAR2(1)  NOT NULL
      CONSTRAINT CKC_IDCONSMINEFECLI_SAP CHECK (IDCONSMINEFECLI IN ('D','P','I')),
   DTVENCONTRCLIE  DATE,
   NRDIAAVISOCVEN  FLOAT,
   CDEXCLIENFIL    VARCHAR2(30),
   IDPERMVENDAFOS  VARCHAR2(1)  NOT NULL
      CONSTRAINT CKC_IDPERMVENDAFOS_SAP CHECK (IDPERMVENDAFOS IN ('S','N')),
   DESPERFAT       VARCHAR2(50),
   CELOG           VARCHAR2(04) NOT NULL,
   CECO            VARCHAR2(10) NOT NULL,
   IDINTERFACE     NUMBER       NOT NULL,
   TPINTERFACE     VARCHAR2(01) NOT NULL
      CONSTRAINT CKC_TPINTERFACE_USR_SAP_CLFIL CHECK (TPINTERFACE IN ('I','A','E')),
   DTINTERFACEORI  DATE         NOT NULL,
   DTINTERFACEDEST DATE,
   STATUS          NUMBER       NOT NULL
      CONSTRAINT CKC_STATUS_USR_SAP_CLFIL CHECK (STATUS IN (0,1,2)),
   APPORIGEM       NUMBER       NOT NULL,
      CONSTRAINT CKC_APPORIGEM_USR_SAP_CLFIL CHECK (APPORIGEM IN (1,2)),
   APPDESTINO      NUMBER       NOT NULL
      CONSTRAINT CKC_APPDESTINO_USR_SAP_CLFIL CHECK (APPDESTINO IN (1,2))
)
/
CREATE SEQUENCE USR_CCH_IDINT_CLIEFI INCREMENT BY 1 MINVALUE 1
/


-- ============================================================
--   TABLE: USR_SAP_NOTAFISCAL
-- ============================================================
CREATE TABLE USR_SAP_NOTAFISCAL
(
   CDUNICO         VARCHAR2(14) NOT NULL,
   IDENTRSAID      VARCHAR2(01) NOT NULL,
   CDEMPINTEGRACAO VARCHAR2(04) NOT NULL,
   CDFILIAL        VARCHAR2(04) NOT NULL,
   CDEXTIPOOPER    VARCHAR2(10) NOT NULL,
   CDINSCRICAO     VARCHAR2(20) NOT NULL,
   CDSERIE         VARCHAR2(05),
   NRNUMERO        VARCHAR2(20),
   CDMODELO        VARCHAR2(02) NOT NULL,
   DTEMISSAO       DATE,
   DTENTRADA       DATE,
   NRACESSONFE     VARCHAR2(44) NULL,
   VRTOTALNF       FLOAT        NOT NULL,
   DTPROC          DATE         NULL,
   DTCONTABILTG    DATE         NULL,
   NRNUMRETG       VARCHAR2(10) NULL,
   CDFILIALTG      VARCHAR2(04) NULL,
   CDIBGEORIG      VARCHAR2(10) NULL,
   CDIBGEDEST      VARCHAR2(10) NULL,
   NRLANCTORIGNF   VARCHAR2(20) NULL,
   CDSERIEORIGNF   VARCHAR2(05) NULL,
   CDFILIORIG      VARCHAR2(04) NULL,
   CDFILIDEST      VARCHAR2(04) NULL,
   IDTPINSJURNF    VARCHAR2(01) NULL,
   NRPROTOCOLONFE  VARCHAR2(15) NULL,
   DTAUTPROTOCOLO  DATE         NULL,
   HRAUTPROTOCOLO  VARCHAR2(08) NULL,
   INCOTERM        VARCHAR2(03) NULL,
   IDSTATUSNFE     VARCHAR2(01) NULL,
   IDNFGERADAVIAXML VARCHAR2(01) NULL,
   VRTOTALAF       FLOAT        NULL,
   VRDIFENFAF      FLOAT        NULL,
   VRTOTDIFNEGATIVO FLOAT       NULL,
   VRTOTDIFPOSITIVO FLOAT       NULL,
   IDPROCNOTADEBCRE VARCHAR2(01) NULL,
   IDEXPORTFECHA   VARCHAR2(01) NULL,
   CDOPERADOREXP   VARCHAR2(12) NULL,
   CELOG           VARCHAR2(04) NOT NULL,
   CECO            VARCHAR2(10) NOT NULL,
   CDEXFORNECED    VARCHAR2(30) NULL,
   IDINTERFACE     NUMBER       NOT NULL,
   TPINTERFACE     VARCHAR2(01) NOT NULL
           CONSTRAINT CKC_TPINTERFACE_USR_SAP_NF CHECK (TPINTERFACE IN ('I','A','E')),
   DTINTERFACEORI  DATE         NOT NULL,
   DTINTERFACEDEST DATE,
   STATUS          NUMBER       NOT NULL
           CONSTRAINT CKC_STATUS_USR_SAP_NF CHECK (STATUS IN (0,1,2,3,4,5)),
   APPORIGEM       NUMBER       NOT NULL
           CONSTRAINT CKC_APPORIGEM_USR_SAP_NF CHECK (APPORIGEM IN (1,2)),
   APPDESTINO      NUMBER       NOT NULL
           CONSTRAINT CKC_APPDESTINO_USR_SAP_NF CHECK (APPDESTINO IN (1,2))
)
/

CREATE SEQUENCE USR_CCH_IDINT_NF INCREMENT BY 1 MINVALUE 1
/


-- ============================================================
--   TABLE: USR_SAP_ITEMPRODUTO
-- ============================================================
CREATE TABLE USR_SAP_ITEMPRODUTO
(
   CDUNICO         VARCHAR2(14) NOT NULL,
   NRSEQITEM       VARCHAR2(04) NOT NULL,
   CDPRODUTO       VARCHAR2(20) NOT NULL,
   VRQUANTIDADE    FLOAT        NOT NULL,
   VRUNITARIO      FLOAT        NOT NULL,
   VRDESCITEM      FLOAT,
   VRTOTAITEM      FLOAT        NOT NULL,
   CDALMOXARIFADO  VARCHAR2(06),
   CDLOCALIZACAO   VARCHAR2(06),
   CDNCM           VARCHAR2(16)  NULL,
   DSPRODEMIS      VARCHAR2(400) NULL,
   NRAUTOFORNE     VARCHAR2(300) NULL,
   VRUNITARIOAF    FLOAT         NULL,
   VRDIFEITNFAF    FLOAT         NULL,
   CDCFOPITPROD    VARCHAR2(11)  NULL,
   CDCSTITPROD     VARCHAR2(03)  NULL,
   NRPEDPROD       VARCHAR2(15)  NULL,
   NRSEQPEDPROD    VARCHAR2(06)  NULL,
   CELOG           VARCHAR2(04)  NOT NULL,
   CECO            VARCHAR2(10)  NOT NULL,
   IDINTERFACE     NUMBER       NOT NULL,
   TPINTERFACE     VARCHAR2(01) NOT NULL
           CONSTRAINT CKC_TPINTERFACE_USR_SAP_ITPROD CHECK (TPINTERFACE IN ('I','A','E')),
   DTINTERFACEORI  DATE         NOT NULL,
   DTINTERFACEDEST DATE,
   STATUS          NUMBER       NOT NULL
           CONSTRAINT CKC_STATUS_USR_SAP_ITPROD CHECK (STATUS IN (0,1,2)),
   APPORIGEM       NUMBER       NOT NULL
           CONSTRAINT CKC_APPORIGEM_USR_SAP_ITPROD CHECK (APPORIGEM IN (1,2)),
   APPDESTINO      NUMBER       NOT NULL
           CONSTRAINT CKC_APPDESTINO_USR_SAP_ITPROD CHECK (APPDESTINO IN (1,2))
)
/

-- ============================================================
--   TABLE: USR_SAP_ITEMPROIMPOS
-- ============================================================
CREATE TABLE USR_SAP_ITEMPROIMPOS
(
   CDUNICO         VARCHAR2(14) NOT NULL,
   NRSEQITEM       VARCHAR2(04) NOT NULL,
   CDOFICIMPO      VARCHAR2(10) NOT NULL,
   VRPERCRED       FLOAT,
   VRBASECALC      FLOAT        NOT NULL,
   VRALIQUOTA      FLOAT        NOT NULL,
   VRIMPOSTO       FLOAT        NOT NULL,
   IDINTERFACE     NUMBER       NOT NULL,
   TPINTERFACE     VARCHAR2(01) NOT NULL
          CONSTRAINT CKC_TPINTERFACE_USR_SAP_PROIMP CHECK (TPINTERFACE IN ('I','A','E')),
   DTINTERFACEORI  DATE         NOT NULL,
   DTINTERFACEDEST DATE,
   STATUS          NUMBER       NOT NULL
          CONSTRAINT CKC_STATUS_USR_SAP_PROIMP CHECK (STATUS IN (0,1,2)),
   APPORIGEM       NUMBER       NOT NULL
          CONSTRAINT CKC_APPORIGEM_USR_SAP_PROIMP CHECK (APPORIGEM IN (1,2)),
   APPDESTINO      NUMBER       NOT NULL
          CONSTRAINT CKC_APPDESTINO_USR_SAP_PROIMP CHECK (APPDESTINO IN (1,2))
)
/
CREATE INDEX USR_SAP_ITEMPROIMPOS_01 ON USR_SAP_ITEMPROIMPOS (CDUNICO ASC)
/


-- ============================================================
--   TABLE: USR_SAP_IMPOSTONF
-- ============================================================
CREATE TABLE USR_SAP_IMPOSTONF
(
   CDUNICO         VARCHAR2(14) NOT NULL,
   NRSEQITEM       VARCHAR2(04) NOT NULL,
   CDOFICIMPO      VARCHAR2(10) NOT NULL,
   VRBASECALC      FLOAT        NOT NULL,
   VRIMPOSTO       FLOAT        NOT NULL,
   IDINTERFACE     NUMBER       NOT NULL,
   TPINTERFACE     VARCHAR2(01) NOT NULL
          CONSTRAINT CKC_TPINTERFACE_USR_SAP_IMPNF CHECK (TPINTERFACE IN ('I','A','E')),
   DTINTERFACEORI  DATE         NOT NULL,
   DTINTERFACEDEST DATE,
   STATUS          NUMBER       NOT NULL
          CONSTRAINT CKC_STATUS_USR_SAP_IMPNF CHECK (STATUS IN (0,1,2)),
   APPORIGEM       NUMBER       NOT NULL
          CONSTRAINT CKC_APPORIGEM_USR_SAP_IMPNF CHECK (APPORIGEM IN (1,2)),
   APPDESTINO      NUMBER       NOT NULL
          CONSTRAINT CKC_APPDESTINO_USR_SAP_IMPNF CHECK (APPDESTINO IN (1,2))
)
/

-- ============================================================
--   TABLE: USR_SAP_ITEMENCARGO
-- ============================================================
CREATE TABLE USR_SAP_ITEMENCARGO
(
   CDUNICO         VARCHAR2(14) NOT NULL,
   CDENCARGO       VARCHAR2(02) NOT NULL,
   VRENCARGO       FLOAT        NOT NULL,
   IDINTERFACE     NUMBER       NOT NULL,
   TPINTERFACE     VARCHAR2(01) NOT NULL,
          CONSTRAINT CKC_TPINTERFACE_USR_SAP_ITENC CHECK (TPINTERFACE IN ('I','A','E')),
   DTINTERFACEORI  DATE         NOT NULL,
   DTINTERFACEDEST DATE,
   STATUS          NUMBER       NOT NULL
          CONSTRAINT CKC_STATUS_USR_SAP_ITENC CHECK (STATUS IN (0,1,2)),
   APPORIGEM       NUMBER       NOT NULL
          CONSTRAINT CKC_APPORIGEM_USR_SAP_ITENC CHECK (APPORIGEM IN (1,2)),
   APPDESTINO      NUMBER       NOT NULL
          CONSTRAINT CKC_APPDESTINO_USR_SAP_ITENC CHECK (APPDESTINO IN (1,2))
)
/

-- ============================================================
--   TABLE: USR_SAP_VENCIMENTOS
-- ============================================================
CREATE TABLE USR_SAP_VENCIMENTOS
(
   CDUNICO         VARCHAR2(14) NOT NULL,
   NRSEQVEN        VARCHAR2(02) NOT NULL,
   NRPARCELA       VARCHAR2(02) NOT NULL,
   CDTIPOCONTA     VARCHAR2(06),
   QTDIASVEN       NUMBER(10)   NOT NULL,
   DTORIGVEN       DATE         NOT NULL,
   VRORIGVEN       FLOAT        NOT NULL,
   IDINTERFACE     NUMBER       NOT NULL,
   TPINTERFACE     VARCHAR2(01) NOT NULL
          CONSTRAINT CKC_TPINTERFACE_USR_SAP_VENC CHECK (TPINTERFACE IN ('I','A','E')),
   DTINTERFACEORI  DATE         NOT NULL,
   DTINTERFACEDEST DATE,
   STATUS          NUMBER       NOT NULL
          CONSTRAINT CKC_STATUS_USR_SAP_VENC CHECK (STATUS IN (0,1,2)),
   APPORIGEM       NUMBER       NOT NULL
          CONSTRAINT CKC_APPORIGEM_USR_SAP_VENC CHECK (APPORIGEM IN (1,2)),
   APPDESTINO      NUMBER       NOT NULL
          CONSTRAINT CKC_APPDESTINO_USR_SAP_VENC CHECK (APPDESTINO IN (1,2))
)
/

-- ============================================================
--   TABLE: USR_SAP_DADOSADIC
-- ============================================================
CREATE TABLE USR_SAP_DADOSADIC
(
   CDUNICO         VARCHAR2(14) NOT NULL,
   NRDADOADIC      VARCHAR2(3)  NOT NULL,
   DSDADOSADIC     VARCHAR2(255) NOT NULL,
   CDMENSAGEM      VARCHAR2(03) NULL,
   IDINTERFACE     NUMBER       NOT NULL,
   TPINTERFACE     VARCHAR2(01) NOT NULL
      CONSTRAINT CKC_TPINTERFACE_USR_DADOSADIC CHECK (TPINTERFACE IN ('I','A','E')),
   DTINTERFACEORI  DATE         NOT NULL,
   DTINTERFACEDEST DATE,
   STATUS          NUMBER       NOT NULL
      CONSTRAINT CKC_STATUS_USR_DADOSADIC CHECK (STATUS IN (0,1,2)),
   APPORIGEM       NUMBER       NOT NULL
      CONSTRAINT CKC_APPORIGEM_USR_DADOSADIC CHECK (APPORIGEM IN (1,2)),
   APPDESTINO      NUMBER       NOT NULL
      CONSTRAINT CKC_APPDESTINO_USR_DADOSADIC CHECK (APPDESTINO IN (1,2))
)
/

-- ============================================================
--   TABLE: USR_SAP_EXPORTACAOTI
-- ============================================================
CREATE TABLE USR_SAP_EXPORTACAOTI
(
   CECO            VARCHAR2(10) NOT NULL,
   CEBE            VARCHAR2(10),
   CDEMPINTEGRACAO VARCHAR2(04) NOT NULL,
   LEDGER          VARCHAR2(02),
   DTDOCENT        VARCHAR2(08),
   DTCONTABILTI    VARCHAR2(08),
   CLASEDOC        VARCHAR2(02) NOT NULL,
   CLASE_MONEDA    VARCHAR2(03) NOT NULL,
   TIPO_CAMBIO     VARCHAR2(03) NULL,
   NRO_REFENCIA    VARCHAR2(20) NOT NULL,
   TEXT_CABECERA   VARCHAR2(20) NOT NULL,
   CLAVE_CONT1     VARCHAR2(20) NOT NULL,
   CTA_MAYOR1      VARCHAR2(10) NOT NULL,
   CLAVE_CONT2     VARCHAR2(20) NOT NULL,
   CTA_MAYOR2      VARCHAR2(10) NOT NULL,
   NRO_ASIGNACION  VARCHAR2(10) NOT NULL,
   TEXT_POSICION   VARCHAR2(50) NOT NULL,
   IMPORTE         FLOAT        NOT NULL,
   IDINTERFACE     NUMBER       NOT NULL,
   TPINTERFACE     VARCHAR2(01) NOT NULL,
          CONSTRAINT CKC_TPINTERFACE_USR_SAP_TI CHECK (TPINTERFACE IN ('I','A','E')),
   DTINTERFACEORI  DATE         NOT NULL,
   DTINTERFACEDEST DATE,
   STATUS          NUMBER       NOT NULL
          CONSTRAINT CKC_STATUS_USR_SAP_TI CHECK (STATUS IN (0,1,2,3)),
   APPORIGEM       NUMBER       NOT NULL
          CONSTRAINT CKC_APPORIGEM_USR_SAP_TI CHECK (APPORIGEM IN (1,2)),
   APPDESTINO      NUMBER       NOT NULL
          CONSTRAINT CKC_APPDESTINO_USR_SAP_TI CHECK (APPDESTINO IN (1,2))
)
/

CREATE SEQUENCE USR_CCH_IDINT_INVE INCREMENT BY 1 MINVALUE 1
/

CREATE SEQUENCE USR_CCH_IDINT_INVG INCREMENT BY 1 MINVALUE 1
/


-- ============================================================
--   TABLE: USR_SAP_LOG
-- ============================================================
CREATE TABLE USR_SAP_LOG
(
   IDINTERFACE NUMBER        NOT NULL,
   IDSEQLOG    VARCHAR2(01)  NOT NULL
        CONSTRAINT CKC_IDSEQLOG_USR_SAP_LOG CHECK (IDSEQLOG IN ('I','A','E')),
   IDPROCESSO  NUMBER        NOT NULL
        CONSTRAINT CKC_IDPROCESSO_USR_SAP_LOG CHECK (IDPROCESSO BETWEEN 1 AND 11),
   DTLOG       DATE          NOT NULL,
   STATUS      NUMBER        NOT NULL
        CONSTRAINT CKC_STATUS_USR_SAP_LOG CHECK (STATUS IN (0,1)),
   OBSSTATUS   VARCHAR2(250) NOT NULL
)
/

ALTER TABLE USR_SAP_LOG MODIFY OBSSTATUS VARCHAR2(2000)
/

-- ============================================================
--   TABLE: USR_PF_VENTA_CABECERA
-- ============================================================
CREATE TABLE USR_PF_VENTA_CABECERA
(
   FUENTELEGACY    VARCHAR2(2) NOT NULL,
   CELOG           VARCHAR2(4) NOT NULL,
   CAJA            VARCHAR2(3) NOT NULL,
   CDEXCLIENTE     VARCHAR2(20) NOT NULL,
   TIPODOCUMENTO   VARCHAR2(2) NULL,
   IDENTIFICADOR   VARCHAR2(20) NOT NULL,
   NROZ            VARCHAR2(20),
   FECHAVENTA      DATE,
   RANGO           VARCHAR2(30),
   IMEI            VARCHAR2(20),
   IDINTERFACE     NUMBER NOT NULL,
   TPINTERFACE VARCHAR2(1)  NOT NULL
      CONSTRAINT CKC_TPINTERFACE_USR_SAP_VEND CHECK (TPINTERFACE IN ('I','A','E')),
   DTINTERFACEORI  DATE     NOT NULL,
   DTINTERFACEDEST DATE,
   STATUS      NUMBER       NOT NULL
      CONSTRAINT CKC_STATUS_USR_SAP_VEND CHECK (STATUS IN (0,1,2,3)),
   APPORIGEM   NUMBER       NOT NULL
      CONSTRAINT CKC_APPORIGEM_USR_SAP_VEND CHECK (APPORIGEM IN (1,2)),
   APPDESTINO  NUMBER       NOT NULL
      CONSTRAINT CKC_APPDESTINO_USR_SAP_VEND CHECK (APPDESTINO IN (1,2))
)
/
CREATE SEQUENCE USR_CCH_IDINT_VEND INCREMENT BY 1 MINVALUE 1
/


-- ============================================================
--   TABLE: USR_PF_VENTA_DETALLE
-- ============================================================
CREATE TABLE USR_PF_VENTA_DETALLE
(
   NRSEQFORMAPGO   NUMBER NOT NULL,
   FORMAPAGO       VARCHAR2(10) NOT NULL,
   MONTOAFECTO     FLOAT NOT NULL,
   MONTOEXENTO     FLOAT NOT NULL,
   IDINTERFACE     NUMBER NOT NULL,
   TPINTERFACE VARCHAR2(1)  NOT NULL
      CONSTRAINT CKC_TPINTERFACE_USR_SAP_FPGO CHECK (TPINTERFACE IN ('I','A','E')),
   DTINTERFACEORI  DATE     NOT NULL,
   DTINTERFACEDEST DATE,
   STATUS      NUMBER       NOT NULL
      CONSTRAINT CKC_STATUS_USR_SAP_FPGO CHECK (STATUS IN (0,1,2,3)),
   APPORIGEM   NUMBER       NOT NULL
      CONSTRAINT CKC_APPORIGEM_USR_SAP_FPGO CHECK (APPORIGEM IN (1,2)),
   APPDESTINO  NUMBER       NOT NULL
      CONSTRAINT CKC_APPDESTINO_USR_SAP_FPGO CHECK (APPDESTINO IN (1,2))
)
/

-- VERSAO --
BEGIN ATUVEROBJ('ATUALIZACAO_ESTRUTURA_BD','6.49.077'); END;
/
