create or replace
PROCEDURE CCH_EXPORTA_NF_SAIDA_SAP(P_DATAINI   IN DATE,
                                   P_DATAFINAL IN DATE,
                                   P_CDFILIAL  IN VARCHAR2,
                                   P_TCDFILIAL IN CHAR,
                                   P_NUMERORE  IN VARCHAR2 DEFAULT NULL,
                                   P_IDTELAEXP IN CHAR DEFAULT 'N')
IS
   V_VERFILIAL    INTEGER;
   V_FILIAL       VARCHAR2(4);
   V_FILIORIG     VARCHAR2(4);
   V_FILIDEST     VARCHAR2(4);
   V_DSREMOTEADDR VARCHAR2(15);
   V_DSREMOTEHOST VARCHAR2(15);
   V_DSSERVERRDM  VARCHAR2(20);
   V_DSSERVMETHOD VARCHAR2(30);
   V_DSREMOTEOPER VARCHAR2(12);

   V_IDINTERFACE  NUMBER;

   V_SEQIMPOSTONF NUMBER;
   V_SEQDADOSADIC NUMBER;
   V_NRSEQITPROD  NUMBER;

   V_VRPRODUTOS   NUMBER;
   V_SOMAIMPOSTO  NUMBER;
   V_SUBTIMPOSTO  NUMBER;
   V_SOMAENCARGO  NUMBER;
   V_SUBTENCARGO  NUMBER;

   V_MENSAGEMERRO VARCHAR2(5000);
BEGIN
   SELECT LENGTH(REGEXP_REPLACE(REGEXP_REPLACE(P_CDFILIAL, '[A-Z]'), '\d'))
     INTO V_VERFILIAL
     FROM DUAL;

   WEBTUNNING(V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVERRDM, V_DSSERVMETHOD, V_DSREMOTEOPER);

   IF ((V_VERFILIAL > 2) OR (P_TCDFILIAL = 'T')) THEN
      FOR C_NOTAFISCAL IN
          (SELECT N.CDFILIAL, N.NRLANCTONF, N.CDFILIAL || N.NRLANCTONF CDUNICO, N.IDENTRSAIDOP, SUBSTR(A.CDEMPINTEGRACAO, 1, 4) AS CDEMPINTEGRACAO,
                  N.CDFILIEMIT, T.CDTIPOOPER AS CDEXTIPOOPER,
                  CASE WHEN N.NRINSJURNF IS NULL
                       THEN N.CDCLIENTE
                       ELSE N.NRINSJURNF
                  END AS CDINSCRICAO,
                  '01' AS CDSERIE, SUBSTR(LPAD(N.NRNOTAFISC, 20, '0'),11,10) AS NRNOTAFISC, '99' AS CDMODDOCFISC, N.DTEMISSAO, N.DTENTRSAID, '' AS NRACESSONFE, N.VRNOTAFISC,
                  N.DTENTRSAID AS DTCONTABILTG, T.IDORIGDESTOP, N.CDFILIRECE,
                  NVL(T.IDORIGDESTOP, 'F') AS IDTPINSJURNF, NRPROTOCOLONFE,
                  TO_CHAR(DTHRPROTOCOLNFE, 'DD/MM/YYYY') AS DTAUTPROTOCOLO, TO_CHAR(DTHRPROTOCOLNFE, 'HH24:MI:SS') AS HRAUTPROTOCOLO,
                  '' AS CDIBGEORIG, '' AS CDIBGEDEST, 'N' AS IDPROCNOTADEBCRE,
                  F.CDCENTCUST AS CELOG,
                  PF.CDEXFILIAL AS CECO,
                  FO.CDEXFORNECED
             FROM NOTAFISCAL N, PARAMFILIAL PF, FILIAL F, TIPOOPERAC T,
                  FORNECEDOR FO, PARAMFORNE PA, PARAMEMPRESA A
            WHERE N.DTENTRSAID BETWEEN P_DATAINI AND (CASE WHEN P_IDTELAEXP = 'S'
                                                          THEN CASE WHEN (PF.DTPROCESSA  <= P_DATAFINAL)
                                                                    THEN PF.DTPROCESSA - 1
                                                                    ELSE TO_DATE(P_DATAFINAL)
                                                               END
                                                          ELSE TO_DATE(P_DATAFINAL)
                                                     END)
              AND ((INSTR(P_CDFILIAL, '_' || N.CDFILIEMIT || '_') > 0) OR (P_TCDFILIAL = 'T'))
              AND N.CDFILIEMIT = PF.CDFILIAL
              AND N.CDFILIEMIT = F.CDFILIAL
              AND N.IDENTRSAIDOP = T.IDENTRSAIDOP
              AND N.CDTIPOOPER   = T.CDTIPOOPER
              AND N.CDMODDOCFISC IS NOT NULL
              AND N.IDENTRSAIDOP = 'S'
              AND A.CDEMPRESA    = N.CDEMPRESA
              AND N.CDFORNECED   = FO.CDFORNECED(+)
              AND FO.CDFORNECED  = PA.CDFORNECED(+)
              AND N.CDFILIAL||N.NRLANCTONF NOT IN (SELECT CDUNICO FROM USR_SAP_NOTAFISCAL)
              AND EXISTS (SELECT I.NRLANCTONF
                            FROM ITEMPRODUTO I
                           WHERE I.CDFILIAL   = N.CDFILIAL
                             AND I.NRLANCTONF = N.NRLANCTONF))
      LOOP
         BEGIN
            V_FILIORIG := NULL;
            V_FILIDEST := NULL;

            IF (C_NOTAFISCAL.IDORIGDESTOP = 'L') THEN
               V_FILIORIG := C_NOTAFISCAL.CDFILIEMIT;
               V_FILIDEST := C_NOTAFISCAL.CDFILIRECE;
            END IF;

            V_IDINTERFACE := USR_CCH_IDINT_NF.NEXTVAL;

            INSERT INTO USR_SAP_NOTAFISCAL
               (CDUNICO, IDENTRSAID, CDEMPINTEGRACAO, CDFILIAL, CDEXTIPOOPER,
                CDINSCRICAO, CDSERIE, NRNUMERO, CDMODELO, DTEMISSAO,
                DTENTRADA, NRACESSONFE, VRTOTALNF,
                DTPROC, DTCONTABILTG, NRNUMRETG, CDFILIALTG, CDIBGEORIG, CDIBGEDEST,
                NRLANCTORIGNF, CDSERIEORIGNF, CDFILIORIG, CDFILIDEST, IDTPINSJURNF,
                NRPROTOCOLONFE, DTAUTPROTOCOLO, HRAUTPROTOCOLO,
                INCOTERM, IDSTATUSNFE, IDNFGERADAVIAXML,
                VRTOTALAF, VRDIFENFAF, VRTOTDIFNEGATIVO, VRTOTDIFPOSITIVO, IDPROCNOTADEBCRE,
                IDEXPORTFECHA, CDOPERADOREXP, CELOG, CECO, CDEXFORNECED,
                IDINTERFACE, TPINTERFACE, DTINTERFACEORI, DTINTERFACEDEST, STATUS, APPORIGEM, APPDESTINO)
            VALUES
               (C_NOTAFISCAL.CDUNICO, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.CDEMPINTEGRACAO, C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.CDEXTIPOOPER,
                C_NOTAFISCAL.CDINSCRICAO, C_NOTAFISCAL.CDSERIE, C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.CDMODDOCFISC, C_NOTAFISCAL.DTEMISSAO,
                C_NOTAFISCAL.DTENTRSAID, C_NOTAFISCAL.NRACESSONFE, C_NOTAFISCAL.VRNOTAFISC,
                C_NOTAFISCAL.DTENTRSAID, C_NOTAFISCAL.DTCONTABILTG, NULL, NULL, C_NOTAFISCAL.CDIBGEORIG, C_NOTAFISCAL.CDIBGEDEST,
                NULL, NULL, V_FILIORIG, V_FILIDEST, C_NOTAFISCAL.IDTPINSJURNF,
                NULL, NULL, NULL,
                NULL, NULL, NULL,
                0, 0, 0, 0, C_NOTAFISCAL.IDPROCNOTADEBCRE,
                'S', V_DSREMOTEOPER, C_NOTAFISCAL.CELOG, C_NOTAFISCAL.CECO, C_NOTAFISCAL.CDEXFORNECED,
                V_IDINTERFACE, 'I', SYSDATE, NULL, 1, 1, 2);

            V_NRSEQITPROD := 10;
            V_VRPRODUTOS  := 0;

            FOR C_ITEMPROD IN
                (SELECT NRSEQITPROD AS NRSEQITPRTEK, P.CDARVPROD, P.CDPRODUTO,
                        I.QTITEMPROD, I.VRUNITITEM, 0 AS VRDESCITEM, I.VRTOTAITEM,
                        '' AS CDNCM, P.NMPRODUTO, I.NRAUTOFORN,
                        '' AS CDFISOPEITEM, '' AS CDSITUTRIBPR, I.CDMARCA
                   FROM ITEMPRODUTO I, PRODUTO P
                  WHERE I.CDFILIAL   = C_NOTAFISCAL.CDFILIAL
                    AND I.NRLANCTONF = C_NOTAFISCAL.NRLANCTONF
                    AND I.CDPRODUTO  = P.CDPRODUTO)
            LOOP
               INSERT INTO USR_SAP_ITEMPRODUTO
                  (CDUNICO, NRSEQITEM, CDPRODUTO, VRQUANTIDADE,
                   VRUNITARIO, VRDESCITEM, VRTOTAITEM, CDALMOXARIFADO, CDLOCALIZACAO,
                   IDINTERFACE, TPINTERFACE, DTINTERFACEORI, DTINTERFACEDEST, STATUS, APPORIGEM, APPDESTINO,
                   CDNCM, DSPRODEMIS, NRAUTOFORNE, VRUNITARIOAF,
                   VRDIFEITNFAF, CDCFOPITPROD, CDCSTITPROD, NRPEDPROD, NRSEQPEDPROD,
                   CELOG, CECO)
               VALUES
                  (C_NOTAFISCAL.CDUNICO, LPAD(TO_CHAR(V_NRSEQITPROD), 4, '0'), C_ITEMPROD.CDARVPROD, C_ITEMPROD.QTITEMPROD,
                   C_ITEMPROD.VRUNITITEM, C_ITEMPROD.VRDESCITEM, C_ITEMPROD.VRTOTAITEM, NULL, NULL,
                   V_IDINTERFACE, 'I', SYSDATE, NULL, 1, 1, 2,
                   C_ITEMPROD.CDNCM, C_ITEMPROD.CDARVPROD ||'-'|| C_ITEMPROD.NMPRODUTO, C_ITEMPROD.NRAUTOFORN, 0,
                   0, C_ITEMPROD.CDFISOPEITEM, C_ITEMPROD.CDSITUTRIBPR, NULL, NULL,
                   C_NOTAFISCAL.CELOG, C_NOTAFISCAL.CECO);

               V_VRPRODUTOS := V_VRPRODUTOS + C_ITEMPROD.VRTOTAITEM;
                
               FOR C_ITEMPROIMPOS IN
                  (SELECT MAX(I.CDOFICIMPO) AS CDOFICIMPO, 0 AS VRPERREDBCIT, SUM(A.VRBASECALCIT) AS VRBASECALCIT, SUM(A.VRALIQITEM) AS VRALIQITEM, SUM(A.VRIMPOSTOIT) AS VRIMPOSTOIT
                     FROM ITEMPROIMPOS A, IMPOSTO I
                    WHERE A.CDFILIAL    = C_NOTAFISCAL.CDFILIAL
                      AND A.NRLANCTONF  = C_NOTAFISCAL.NRLANCTONF
                      AND A.NRSEQITPROD = C_ITEMPROD.NRSEQITPRTEK
                      AND I.CDIMPOSTO   = A.CDIMPOSTO
                      AND A.VRIMPOSTOIT > 0)
               LOOP
                  INSERT INTO USR_SAP_ITEMPROIMPOS
                     (CDUNICO, NRSEQITEM, CDOFICIMPO, VRPERCRED, VRBASECALC,
                      VRALIQUOTA, VRIMPOSTO,
                      IDINTERFACE, TPINTERFACE, DTINTERFACEORI, DTINTERFACEDEST, STATUS, APPORIGEM, APPDESTINO)
                  VALUES
                     (C_NOTAFISCAL.CDUNICO, LPAD(TO_CHAR(V_NRSEQITPROD), 4, '0'), C_ITEMPROIMPOS.CDOFICIMPO, C_ITEMPROIMPOS.VRPERREDBCIT, C_ITEMPROIMPOS.VRBASECALCIT,
                      C_ITEMPROIMPOS.VRALIQITEM, C_ITEMPROIMPOS.VRIMPOSTOIT,
                      V_IDINTERFACE, 'I', SYSDATE, NULL, 1, 1, 2);
               END LOOP;

               V_NRSEQITPROD := V_NRSEQITPROD + 10;
            END LOOP;

            V_SEQIMPOSTONF := 1;
            V_SOMAIMPOSTO  := 0;
            V_SUBTIMPOSTO  := 0;

            FOR C_IMPOSTONF IN
               (SELECT I.IDTRATIMPO, U.CDOFICIMPO, SUM(U.VRBASECALC) AS VRBASECALCNF, ROUND(SUM(U.VRIMPOSTO),0) AS VRIMPOSTONF
                  FROM USR_SAP_ITEMPROIMPOS U, IMPOSTO I
                 WHERE U.CDUNICO = C_NOTAFISCAL.CDFILIAL||C_NOTAFISCAL.NRLANCTONF
                   AND U.CDOFICIMPO = I.CDOFICIMPO
                 GROUP BY I.IDTRATIMPO, U.CDOFICIMPO)
            LOOP
               INSERT INTO USR_SAP_IMPOSTONF
                  (CDUNICO, NRSEQITEM, CDOFICIMPO, VRBASECALC, VRIMPOSTO,
                   IDINTERFACE, TPINTERFACE, DTINTERFACEORI, DTINTERFACEDEST, STATUS, APPORIGEM, APPDESTINO)
               VALUES
                  (C_NOTAFISCAL.CDUNICO, LPAD(TO_CHAR(V_SEQIMPOSTONF * 10), 4, '0'), C_IMPOSTONF.CDOFICIMPO, C_IMPOSTONF.VRBASECALCNF, C_IMPOSTONF.VRIMPOSTONF,
                   V_IDINTERFACE, 'I', SYSDATE, NULL, 1, 1, 2);

               IF C_IMPOSTONF.IDTRATIMPO = 'A' THEN
                  V_SOMAIMPOSTO := V_SOMAIMPOSTO + C_IMPOSTONF.VRIMPOSTONF;
               END IF;

               IF C_IMPOSTONF.IDTRATIMPO = 'D' THEN
                  V_SUBTIMPOSTO := V_SUBTIMPOSTO + C_IMPOSTONF.VRIMPOSTONF;
               END IF;
                
               V_SEQIMPOSTONF := V_SEQIMPOSTONF + 1;
            END LOOP;

            V_SOMAENCARGO := 0;
            V_SUBTENCARGO := 0;
         
            FOR C_ITEMENCARGO IN
               (SELECT E.IDENCARGO, I.CDENCARGO, ROUND(I.VRITEMENCA, 0) AS VRITEMENCA
                  FROM ITEMENCARGO I, ENCARGO E
                 WHERE I.CDFILIAL   = C_NOTAFISCAL.CDFILIAL
                   AND I.NRLANCTONF = C_NOTAFISCAL.NRLANCTONF
                   AND I.CDENCARGO  = E.CDENCARGO)
            LOOP
               INSERT INTO USR_SAP_ITEMENCARGO
                  (CDUNICO, CDENCARGO, VRENCARGO, IDINTERFACE, TPINTERFACE, DTINTERFACEORI, DTINTERFACEDEST, STATUS, APPORIGEM, APPDESTINO)
               VALUES
                  (C_NOTAFISCAL.CDUNICO, C_ITEMENCARGO.CDENCARGO, C_ITEMENCARGO.VRITEMENCA, V_IDINTERFACE, 'I', SYSDATE, NULL, 1, 1, 2);

               IF C_ITEMENCARGO.IDENCARGO = 'A' THEN
                  V_SOMAENCARGO := V_SOMAENCARGO + C_ITEMENCARGO.VRITEMENCA;
               END IF;

               IF C_ITEMENCARGO.IDENCARGO = 'D' THEN
                  V_SUBTENCARGO := V_SUBTENCARGO + C_ITEMENCARGO.VRITEMENCA;
               END IF;
            END LOOP;

            FOR C_VENCIMENTO IN
               (SELECT '01' AS NRSEQVENPAG, '00' AS NRPARCELAPAG, '' AS CDTPCTPAGAR, QTDIASVENPAG, DTORIGVENPAG, VRORIGPAG
                  FROM CONTAPAGAR
                 WHERE CDFILIAL   = C_NOTAFISCAL.CDFILIAL
                   AND NRLANCTONF = C_NOTAFISCAL.NRLANCTONF)
            LOOP
               INSERT INTO USR_SAP_VENCIMENTOS
                  (CDUNICO, NRSEQVEN, NRPARCELA, CDTIPOCONTA, QTDIASVEN,
                   DTORIGVEN, VRORIGVEN, IDINTERFACE, TPINTERFACE, DTINTERFACEORI, DTINTERFACEDEST, STATUS, APPORIGEM, APPDESTINO)
               VALUES
                  (C_NOTAFISCAL.CDUNICO, C_VENCIMENTO.NRSEQVENPAG, C_VENCIMENTO.NRPARCELAPAG, C_VENCIMENTO.CDTPCTPAGAR, C_VENCIMENTO.QTDIASVENPAG,
                   C_VENCIMENTO.DTORIGVENPAG, C_VENCIMENTO.VRORIGPAG, V_IDINTERFACE, 'I', SYSDATE, NULL, 1, 1, 2);
            END LOOP;

            V_SEQDADOSADIC := 1;

            FOR C_DADOSADIC IN
               (SELECT DSDADOADIC
                  FROM DADOSADIC
                 WHERE CDFILIAL   = C_NOTAFISCAL.CDFILIAL
                   AND NRLANCTONF = C_NOTAFISCAL.NRLANCTONF)
            LOOP
               INSERT INTO USR_SAP_DADOSADIC
                  (CDUNICO, NRDADOADIC, DSDADOSADIC, CDMENSAGEM,
                   IDINTERFACE, TPINTERFACE, DTINTERFACEORI, DTINTERFACEDEST, STATUS, APPORIGEM, APPDESTINO)
               VALUES
                  (C_NOTAFISCAL.CDUNICO, LPAD(TO_CHAR(V_SEQDADOSADIC * 10), 3, '0'), C_DADOSADIC.DSDADOADIC, NULL,
                   V_IDINTERFACE, 'I', SYSDATE, NULL, 1, 1, 2);
            END LOOP;

            UPDATE USR_SAP_NOTAFISCAL
               SET VRTOTALNF = (ROUND(V_VRPRODUTOS, 0) + V_SOMAIMPOSTO - V_SUBTIMPOSTO + V_SOMAENCARGO - V_SUBTENCARGO)
             WHERE CDUNICO = C_NOTAFISCAL.CDFILIAL||C_NOTAFISCAL.NRLANCTONF;
         
            COMMIT;

         EXCEPTION
            WHEN OTHERS THEN BEGIN
               V_MENSAGEMERRO := SQLERRM(SQLCODE);
               ROLLBACK;

               INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
               VALUES(V_IDINTERFACE, 'I', 7, SYSDATE, 1, 'CDUNICO ' || C_NOTAFISCAL.CDFILIAL||C_NOTAFISCAL.NRLANCTONF || ' - ' || SUBSTR(V_MENSAGEMERRO,1,1973));

               COMMIT;
            END;
         END;
      END LOOP;
   ELSE
      SELECT REPLACE(P_CDFILIAL, '_')
        INTO V_FILIAL
        FROM DUAL;

      FOR C_NOTAFISCAL IN
          (SELECT N.CDFILIAL, N.NRLANCTONF, N.CDFILIAL || N.NRLANCTONF CDUNICO, N.IDENTRSAIDOP, SUBSTR(A.CDEMPINTEGRACAO, 1, 4) AS CDEMPINTEGRACAO,
                  N.CDFILIEMIT, T.CDTIPOOPER AS CDEXTIPOOPER,
                  CASE WHEN N.NRINSJURNF IS NULL
                       THEN N.CDCLIENTE
                       ELSE N.NRINSJURNF
                  END AS CDINSCRICAO,
                  '01' AS CDSERIE, SUBSTR(LPAD(N.NRNOTAFISC, 20, '0'),11,10) AS NRNOTAFISC, '99' AS CDMODDOCFISC, N.DTEMISSAO, N.DTENTRSAID, '' AS NRACESSONFE, N.VRNOTAFISC,
                  N.DTENTRSAID AS DTCONTABILTG, T.IDORIGDESTOP, N.CDFILIRECE,
                  NVL(T.IDORIGDESTOP, 'F') AS IDTPINSJURNF, NRPROTOCOLONFE,
                  TO_CHAR(DTHRPROTOCOLNFE, 'DD/MM/YYYY') AS DTAUTPROTOCOLO, TO_CHAR(DTHRPROTOCOLNFE, 'HH24:MI:SS') AS HRAUTPROTOCOLO,
                  '' AS CDIBGEORIG, '' AS CDIBGEDEST, 'N' AS IDPROCNOTADEBCRE,
                  F.CDCENTCUST AS CELOG,
                  PF.CDEXFILIAL AS CECO,
                  FO.CDEXFORNECED
             FROM NOTAFISCAL N, PARAMFILIAL PF, FILIAL F, TIPOOPERAC T,
                  FORNECEDOR FO, PARAMFORNE PA, PARAMEMPRESA A
            WHERE N.DTENTRSAID BETWEEN P_DATAINI AND (CASE WHEN P_IDTELAEXP = 'S'
                                                          THEN CASE WHEN (PF.DTPROCESSA  <= P_DATAFINAL)
                                                                    THEN PF.DTPROCESSA - 1
                                                                    ELSE TO_DATE(P_DATAFINAL)
                                                               END
                                                          ELSE TO_DATE(P_DATAFINAL)
                                                     END)
              AND N.CDFILIEMIT = V_FILIAL
              AND N.CDFILIEMIT = PF.CDFILIAL
              AND N.CDFILIEMIT = F.CDFILIAL
              AND N.IDENTRSAIDOP = T.IDENTRSAIDOP
              AND N.CDTIPOOPER   = T.CDTIPOOPER
              AND N.CDMODDOCFISC IS NOT NULL
              AND N.IDENTRSAIDOP = 'S'
              AND A.CDEMPRESA    = N.CDEMPRESA
              AND N.CDFORNECED   = FO.CDFORNECED(+)
              AND FO.CDFORNECED  = PA.CDFORNECED(+)
              AND N.CDFILIAL||N.NRLANCTONF NOT IN (SELECT CDUNICO FROM USR_SAP_NOTAFISCAL)
              AND EXISTS (SELECT I.NRLANCTONF
                            FROM ITEMPRODUTO I
                           WHERE I.CDFILIAL = N.CDFILIAL
                             AND I.NRLANCTONF = N.NRLANCTONF))
      LOOP
         BEGIN
            V_FILIORIG := NULL;
            V_FILIDEST := NULL;

            IF (C_NOTAFISCAL.IDORIGDESTOP = 'L') THEN
               V_FILIORIG := C_NOTAFISCAL.CDFILIEMIT;
               V_FILIDEST := C_NOTAFISCAL.CDFILIRECE;
            END IF;

            V_IDINTERFACE := USR_CCH_IDINT_NF.NEXTVAL;

            INSERT INTO USR_SAP_NOTAFISCAL
               (CDUNICO, IDENTRSAID, CDEMPINTEGRACAO, CDFILIAL, CDEXTIPOOPER,
                CDINSCRICAO, CDSERIE, NRNUMERO, CDMODELO, DTEMISSAO,
                DTENTRADA, NRACESSONFE, VRTOTALNF,
                DTPROC, DTCONTABILTG, NRNUMRETG, CDFILIALTG, CDIBGEORIG, CDIBGEDEST,
                NRLANCTORIGNF, CDSERIEORIGNF, CDFILIORIG, CDFILIDEST, IDTPINSJURNF,
                NRPROTOCOLONFE, DTAUTPROTOCOLO, HRAUTPROTOCOLO,
                INCOTERM, IDSTATUSNFE, IDNFGERADAVIAXML,
                VRTOTALAF, VRDIFENFAF, VRTOTDIFNEGATIVO, VRTOTDIFPOSITIVO, IDPROCNOTADEBCRE,
                IDEXPORTFECHA, CDOPERADOREXP, CELOG, CECO, CDEXFORNECED,
                IDINTERFACE, TPINTERFACE, DTINTERFACEORI, DTINTERFACEDEST, STATUS, APPORIGEM, APPDESTINO)
            VALUES
               (C_NOTAFISCAL.CDUNICO, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.CDEMPINTEGRACAO, C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.CDEXTIPOOPER,
                C_NOTAFISCAL.CDINSCRICAO, C_NOTAFISCAL.CDSERIE, C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.CDMODDOCFISC, C_NOTAFISCAL.DTEMISSAO,
                C_NOTAFISCAL.DTENTRSAID, C_NOTAFISCAL.NRACESSONFE, C_NOTAFISCAL.VRNOTAFISC,
                C_NOTAFISCAL.DTENTRSAID, C_NOTAFISCAL.DTCONTABILTG, NULL, NULL, C_NOTAFISCAL.CDIBGEORIG, C_NOTAFISCAL.CDIBGEDEST,
                NULL, NULL, V_FILIORIG, V_FILIDEST, C_NOTAFISCAL.IDTPINSJURNF,
                NULL, NULL, NULL,
                NULL, NULL, NULL,
                0, 0, 0, 0, C_NOTAFISCAL.IDPROCNOTADEBCRE,
                'S', V_DSREMOTEOPER, C_NOTAFISCAL.CELOG, C_NOTAFISCAL.CECO, C_NOTAFISCAL.CDEXFORNECED,
                V_IDINTERFACE, 'I', SYSDATE, NULL, 1, 1, 2);

            V_NRSEQITPROD := 10;
            V_VRPRODUTOS  := 0;

            FOR C_ITEMPROD IN
                (SELECT NRSEQITPROD AS NRSEQITPRTEK, P.CDARVPROD, P.CDPRODUTO,
                        I.QTITEMPROD, I.VRUNITITEM, 0 AS VRDESCITEM, I.VRTOTAITEM,
                        '' AS CDNCM, P.NMPRODUTO, I.NRAUTOFORN,
                        '' AS CDFISOPEITEM, '' AS CDSITUTRIBPR, I.CDMARCA
                   FROM ITEMPRODUTO I, PRODUTO P
                  WHERE I.CDFILIAL   = C_NOTAFISCAL.CDFILIAL
                    AND I.NRLANCTONF = C_NOTAFISCAL.NRLANCTONF
                    AND I.CDPRODUTO  = P.CDPRODUTO)
            LOOP
               INSERT INTO USR_SAP_ITEMPRODUTO
                  (CDUNICO, NRSEQITEM, CDPRODUTO, VRQUANTIDADE,
                   VRUNITARIO, VRDESCITEM, VRTOTAITEM, CDALMOXARIFADO, CDLOCALIZACAO,
                   IDINTERFACE, TPINTERFACE, DTINTERFACEORI, DTINTERFACEDEST, STATUS, APPORIGEM, APPDESTINO,
                   CDNCM, DSPRODEMIS, NRAUTOFORNE, VRUNITARIOAF,
                   VRDIFEITNFAF, CDCFOPITPROD, CDCSTITPROD, NRPEDPROD, NRSEQPEDPROD,
                   CELOG, CECO)
               VALUES
                  (C_NOTAFISCAL.CDUNICO, LPAD(TO_CHAR(V_NRSEQITPROD), 4, '0'), C_ITEMPROD.CDARVPROD, C_ITEMPROD.QTITEMPROD,
                   C_ITEMPROD.VRUNITITEM, C_ITEMPROD.VRDESCITEM, C_ITEMPROD.VRTOTAITEM, NULL, NULL,
                   V_IDINTERFACE, 'I', SYSDATE, NULL, 1, 1, 2,
                   C_ITEMPROD.CDNCM, C_ITEMPROD.CDARVPROD ||'-'|| C_ITEMPROD.NMPRODUTO, C_ITEMPROD.NRAUTOFORN, 0,
                   0, C_ITEMPROD.CDFISOPEITEM, C_ITEMPROD.CDSITUTRIBPR, NULL, NULL,
                   C_NOTAFISCAL.CELOG, C_NOTAFISCAL.CECO);

               V_VRPRODUTOS := V_VRPRODUTOS + C_ITEMPROD.VRTOTAITEM;

               FOR C_ITEMPROIMPOS IN
                  (SELECT MAX(I.CDOFICIMPO) AS CDOFICIMPO, 0 AS VRPERREDBCIT, SUM(A.VRBASECALCIT) AS VRBASECALCIT, SUM(A.VRALIQITEM) AS VRALIQITEM, SUM(A.VRIMPOSTOIT) AS VRIMPOSTOIT
                     FROM ITEMPROIMPOS A, IMPOSTO I
                    WHERE A.CDFILIAL    = C_NOTAFISCAL.CDFILIAL
                      AND A.NRLANCTONF  = C_NOTAFISCAL.NRLANCTONF
                      AND A.NRSEQITPROD = C_ITEMPROD.NRSEQITPRTEK
                      AND I.CDIMPOSTO   = A.CDIMPOSTO
                      AND A.VRIMPOSTOIT > 0)
               LOOP
                  INSERT INTO USR_SAP_ITEMPROIMPOS
                     (CDUNICO, NRSEQITEM, CDOFICIMPO, VRPERCRED, VRBASECALC,
                      VRALIQUOTA, VRIMPOSTO,
                      IDINTERFACE, TPINTERFACE, DTINTERFACEORI, DTINTERFACEDEST, STATUS, APPORIGEM, APPDESTINO)
                  VALUES
                     (C_NOTAFISCAL.CDUNICO, LPAD(TO_CHAR(V_NRSEQITPROD), 4, '0'), C_ITEMPROIMPOS.CDOFICIMPO, C_ITEMPROIMPOS.VRPERREDBCIT, C_ITEMPROIMPOS.VRBASECALCIT,
                      C_ITEMPROIMPOS.VRALIQITEM, C_ITEMPROIMPOS.VRIMPOSTOIT,
                      V_IDINTERFACE, 'I', SYSDATE, NULL, 1, 1, 2);
               END LOOP;

               V_NRSEQITPROD := V_NRSEQITPROD + 10;
            END LOOP;

            V_SEQIMPOSTONF := 1;
            V_SOMAIMPOSTO  := 0;
            V_SUBTIMPOSTO  := 0;

            FOR C_IMPOSTONF IN
               (SELECT I.IDTRATIMPO, U.CDOFICIMPO, SUM(U.VRBASECALC) AS VRBASECALCNF, ROUND(SUM(U.VRIMPOSTO),0) AS VRIMPOSTONF
                  FROM USR_SAP_ITEMPROIMPOS U, IMPOSTO I
                 WHERE U.CDUNICO = C_NOTAFISCAL.CDFILIAL||C_NOTAFISCAL.NRLANCTONF
                   AND U.CDOFICIMPO = I.CDOFICIMPO
                 GROUP BY I.IDTRATIMPO, U.CDOFICIMPO)
            LOOP
               INSERT INTO USR_SAP_IMPOSTONF
                  (CDUNICO, NRSEQITEM, CDOFICIMPO, VRBASECALC, VRIMPOSTO,
                   IDINTERFACE, TPINTERFACE, DTINTERFACEORI, DTINTERFACEDEST, STATUS, APPORIGEM, APPDESTINO)
               VALUES
                  (C_NOTAFISCAL.CDUNICO, LPAD(TO_CHAR(V_SEQIMPOSTONF * 10), 4, '0'), C_IMPOSTONF.CDOFICIMPO, C_IMPOSTONF.VRBASECALCNF, C_IMPOSTONF.VRIMPOSTONF,
                   V_IDINTERFACE, 'I', SYSDATE, NULL, 1, 1, 2);

               IF C_IMPOSTONF.IDTRATIMPO = 'A' THEN
                  V_SOMAIMPOSTO := V_SOMAIMPOSTO + C_IMPOSTONF.VRIMPOSTONF;
               END IF;

               IF C_IMPOSTONF.IDTRATIMPO = 'D' THEN
                  V_SUBTIMPOSTO := V_SUBTIMPOSTO + C_IMPOSTONF.VRIMPOSTONF;
               END IF;

               V_SEQIMPOSTONF := V_SEQIMPOSTONF + 1;
            END LOOP;

            V_SOMAENCARGO := 0;
            V_SUBTENCARGO := 0;

            FOR C_ITEMENCARGO IN
               (SELECT E.IDENCARGO, I.CDENCARGO, ROUND(I.VRITEMENCA, 0) AS VRITEMENCA
                  FROM ITEMENCARGO I, ENCARGO E
                 WHERE I.CDFILIAL   = C_NOTAFISCAL.CDFILIAL
                   AND I.NRLANCTONF = C_NOTAFISCAL.NRLANCTONF
                   AND I.CDENCARGO  = E.CDENCARGO)
            LOOP
               INSERT INTO USR_SAP_ITEMENCARGO
                  (CDUNICO, CDENCARGO, VRENCARGO, IDINTERFACE, TPINTERFACE, DTINTERFACEORI, DTINTERFACEDEST, STATUS, APPORIGEM, APPDESTINO)
               VALUES
                  (C_NOTAFISCAL.CDUNICO, C_ITEMENCARGO.CDENCARGO, C_ITEMENCARGO.VRITEMENCA, V_IDINTERFACE, 'I', SYSDATE, NULL, 1, 1, 2);

               IF C_ITEMENCARGO.IDENCARGO = 'A' THEN
                  V_SOMAENCARGO := V_SOMAENCARGO + C_ITEMENCARGO.VRITEMENCA;
               END IF;

               IF C_ITEMENCARGO.IDENCARGO = 'D' THEN
                  V_SUBTENCARGO := V_SUBTENCARGO + C_ITEMENCARGO.VRITEMENCA;
               END IF;
            END LOOP;

            FOR C_VENCIMENTO IN
               (SELECT '01' AS NRSEQVENPAG, '00' AS NRPARCELAPAG, '' AS CDTPCTPAGAR, QTDIASVENPAG, DTORIGVENPAG, VRORIGPAG
                  FROM CONTAPAGAR
                 WHERE CDFILIAL   = C_NOTAFISCAL.CDFILIAL
                   AND NRLANCTONF = C_NOTAFISCAL.NRLANCTONF)
            LOOP
               INSERT INTO USR_SAP_VENCIMENTOS
                  (CDUNICO, NRSEQVEN, NRPARCELA, CDTIPOCONTA, QTDIASVEN,
                   DTORIGVEN, VRORIGVEN, IDINTERFACE, TPINTERFACE, DTINTERFACEORI, DTINTERFACEDEST, STATUS, APPORIGEM, APPDESTINO)
               VALUES
                  (C_NOTAFISCAL.CDUNICO, C_VENCIMENTO.NRSEQVENPAG, C_VENCIMENTO.NRPARCELAPAG, C_VENCIMENTO.CDTPCTPAGAR, C_VENCIMENTO.QTDIASVENPAG,
                   C_VENCIMENTO.DTORIGVENPAG, C_VENCIMENTO.VRORIGPAG, V_IDINTERFACE, 'I', SYSDATE, NULL, 1, 1, 2);
            END LOOP;

            V_SEQDADOSADIC := 1;

            FOR C_DADOSADIC IN
               (SELECT DSDADOADIC
                  FROM DADOSADIC
                 WHERE CDFILIAL   = C_NOTAFISCAL.CDFILIAL
                   AND NRLANCTONF = C_NOTAFISCAL.NRLANCTONF)
            LOOP
               INSERT INTO USR_SAP_DADOSADIC
                  (CDUNICO, NRDADOADIC, DSDADOSADIC, CDMENSAGEM,
                   IDINTERFACE, TPINTERFACE, DTINTERFACEORI, DTINTERFACEDEST, STATUS, APPORIGEM, APPDESTINO)
               VALUES
                  (C_NOTAFISCAL.CDUNICO, LPAD(TO_CHAR(V_SEQDADOSADIC * 10), 3, '0'), C_DADOSADIC.DSDADOADIC, NULL,
                   V_IDINTERFACE, 'I', SYSDATE, NULL, 1, 1, 2);
            END LOOP;

            UPDATE USR_SAP_NOTAFISCAL
               SET VRTOTALNF = (ROUND(V_VRPRODUTOS, 0) + V_SOMAIMPOSTO - V_SUBTIMPOSTO + V_SOMAENCARGO - V_SUBTENCARGO)
             WHERE CDUNICO = C_NOTAFISCAL.CDFILIAL||C_NOTAFISCAL.NRLANCTONF;

            COMMIT;

         EXCEPTION
            WHEN OTHERS THEN BEGIN
               V_MENSAGEMERRO := SQLERRM(SQLCODE);
               ROLLBACK;

               INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
               VALUES(V_IDINTERFACE, 'I', 7, SYSDATE, 1, 'CDUNICO ' || C_NOTAFISCAL.CDFILIAL||C_NOTAFISCAL.NRLANCTONF || ' - ' || SUBSTR(V_MENSAGEMERRO,1,1973));

               COMMIT;
            END;
         END;
      END LOOP;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('CCH_EXPORTA_NF_SAIDA_SAP','6.49.077'); END;
/

